import * as sendGrid from "@sendgrid/mail";
import { BaseService, UtilityService } from "../../../common";
import { MsgTemplate } from "./entities/msgtemplate.entity";
export declare class MsgTemplateService extends BaseService<MsgTemplate> {
    private readonly model;
    private readonly msgtemplateRepository;
    private utilityService;
    constructor(model: MsgTemplate, msgtemplateRepository: typeof MsgTemplate, utilityService: UtilityService);
    getGlobalVariable(): Promise<any>;
    createMsgTemplate(createMsgTemplateDto: any): Promise<any>;
    getMsgTemplate(id: string): Promise<MsgTemplate[]>;
    loadTemplate(id: string): Promise<MsgTemplate>;
    execute(query: any): Promise<any[]>;
    getMessageTemplate(temp: any): Promise<MsgTemplate | {
        statusCode: number;
        message: string;
        error: unknown;
    }>;
    generateCronPDF({ values }: {
        values: any;
    }): Promise<[sendGrid.ClientResponse, {}]>;
    generateCronwithPdfAttachment({ values }: {
        values: any;
    }): Promise<[sendGrid.ClientResponse, {}]>;
    cronMail({ values, attachment }: {
        values: any;
        attachment: any;
    }): Promise<[sendGrid.ClientResponse, {}]>;
    cronNotificationMail(values: any, error: any): Promise<[sendGrid.ClientResponse, {}]>;
    sendCronMail({ body, values }: {
        body: any;
        values: any;
    }): Promise<[sendGrid.ClientResponse, {}]>;
    generatePDF({ subject, table_data, headings_uniq }: any): Promise<unknown>;
}
