"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MsgTemplateService = void 0;
const common_1 = require("@nestjs/common");
const sendGrid = __importStar(require("@sendgrid/mail"));
const handlebars_1 = __importDefault(require("handlebars"));
const common_2 = require("../../../common");
const msgtemplate_entity_1 = require("./entities/msgtemplate.entity");
const constants_1 = require("../../../common/constants");
const html_to_pdf = require("html-pdf-node");
const cheerio = require("cheerio");
const PDFDocument = require("pdfkit-table");
let MsgTemplateService = class MsgTemplateService extends common_2.BaseService {
    constructor(model, msgtemplateRepository, utilityService) {
        super(model);
        this.model = model;
        this.msgtemplateRepository = msgtemplateRepository;
        this.utilityService = utilityService;
    }
    getGlobalVariable() {
        return __awaiter(this, void 0, void 0, function* () {
            let values = [
                {
                    firm: "Nura",
                    branch: "",
                    from_date: "",
                    to_date: "",
                    start_of_week: "",
                    end_of_week: "",
                    start_of_month: "",
                    end_of_month: "",
                },
            ];
            return values;
        });
    }
    createMsgTemplate(createMsgTemplateDto) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.msgtemplateRepository
                .create(createMsgTemplateDto)
                .then((result) => {
                return result;
            })
                .catch((error) => {
                return error;
            });
        });
    }
    getMsgTemplate(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.msgtemplateRepository.findAll({
                where: {
                    mt_code: id,
                },
            });
        });
    }
    loadTemplate(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.msgtemplateRepository.findOne({
                where: {
                    mt_code: id,
                },
            });
        });
    }
    execute(query) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.msgtemplateRepository.sequelize.query(query);
        });
    }
    getMessageTemplate(temp) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const template = yield this.msgtemplateRepository.findOne({
                    where: { mt_code: temp.template_code },
                });
                if (template.mt_otherdetails) {
                    return template;
                }
            }
            catch (error) {
                return {
                    statusCode: 403,
                    message: "failed",
                    error,
                };
            }
        });
    }
    generateCronPDF({ values }) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                console.log("VALUESSSS", values);
                let subject = values.otherDetails.subject;
                let pdfTemplatecode;
                let arr;
                const globalVariable = yield this.getGlobalVariable();
                globalVariable.forEach((ele) => {
                    let field = Object.keys(ele);
                    for (let i = 0; i < field.length; i++) {
                        subject = subject.replace("@" + field[i] + ";", ele[field[i]]);
                    }
                });
                if (values.otherDetails.template_code) {
                    pdfTemplatecode = yield this.getMessageTemplate(values.otherDetails);
                }
                let replacements = {
                    table: values.templateContent,
                    subject: subject,
                };
                let str = values.messageTemplate.mt_message;
                var template = handlebars_1.default.compile(str);
                if (pdfTemplatecode) {
                    let string = pdfTemplatecode.mt_message;
                    var pdfTemplateContent = handlebars_1.default.compile(string);
                    var htmlToMail = pdfTemplateContent(replacements);
                    const parsedHtml = cheerio.load(htmlToMail);
                    const footer = parsedHtml(".footer");
                    const header = parsedHtml(".header");
                    const removeHeader = parsedHtml(".header").remove();
                    const removeFooter = parsedHtml(".footer").remove();
                    let styles = null;
                    let file = { content: parsedHtml.html() };
                    arr = yield this.utilityService.htmlToPdf(file, footer, header, values, styles);
                }
                var htmlToSend = template(replacements);
                let fileContent = { content: htmlToSend };
                let options = { format: "A4" };
                let csvString = values.messageTemplate.mt_receivers;
                const rows = csvString.split(",");
                const array = rows.map((row) => row);
                let body = {
                    to: array,
                    from: process.env.EMAIL_NURA,
                    subject: subject,
                    html: htmlToSend,
                    attachments: [],
                };
                const sendMail = this.sendCronMail({ body, values });
                return sendMail;
            }
            catch (error) {
                console.log("----------ERROR", error);
                if (values.cronConfiguration.alert_notification === "Y") {
                    const email = values.cronConfiguration.notification_email_to;
                    const rows = email.split(",");
                    const array = rows.map((row) => row);
                    let body = {
                        to: array,
                        from: process.env.EMAIL_NURA,
                        subject: "failed",
                        html: "Cron Failed",
                    };
                    const sendMail = this.sendCronMail({ body, values });
                    return sendMail;
                }
            }
        });
    }
    generateCronwithPdfAttachment({ values }) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let subject = values.otherDetails.subject;
                let arr;
                const globalVariable = yield this.getGlobalVariable();
                globalVariable.forEach((ele) => {
                    let field = Object.keys(ele);
                    for (let i = 0; i < field.length; i++) {
                        subject = subject.replace("@" + field[i] + ";", ele[field[i]]);
                    }
                });
                let pdfTemplatecode = yield this.getMessageTemplate(values.otherDetails);
                let replacements = {
                    table: values.templateContent,
                    subject: subject,
                };
                let string = pdfTemplatecode.mt_message;
                var pdfTemplateContent = handlebars_1.default.compile(string);
                var htmlToMail = pdfTemplateContent(replacements);
                const parsedHtml = cheerio.load(htmlToMail);
                const footer = parsedHtml(".footer");
                const header = parsedHtml(".header");
                let file = { content: parsedHtml.html() };
                let styles = {};
                arr = yield this.utilityService.htmlToPdf(file, footer, header, values, styles);
                var bytes = btoa(new Uint8Array(arr).reduce(function (data, byte) {
                    return data + String.fromCharCode(byte);
                }, ""));
                const attachment = {
                    attachments: [
                        {
                            filename: `${values.cronConfiguration.description}.pdf`,
                            content: bytes,
                            type: "application/pdf",
                            disposition: "attachment",
                        },
                    ],
                };
                const sendMail = this.cronMail({ values, attachment });
                return sendMail;
            }
            catch (error) {
                return yield this.cronNotificationMail(values, error);
            }
        });
    }
    cronMail({ values, attachment }) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let subject = values.otherDetails.subject;
                const globalVariable = yield this.getGlobalVariable();
                globalVariable.forEach((ele) => {
                    let field = Object.keys(ele);
                    for (let i = 0; i < field.length; i++) {
                        subject = subject.replace("@" + field[i] + ";", ele[field[i]]);
                    }
                });
                let replacements = {
                    table: values.templateContent,
                    subject: subject,
                };
                let str = values.messageTemplate.mt_message;
                var template = handlebars_1.default.compile(str);
                var htmlToSend = template(replacements);
                let csvString = values.messageTemplate.mt_receivers;
                const rows = csvString.split(",");
                const array = rows.map((row) => row);
                let body = {
                    to: array,
                    from: process.env.EMAIL_NURA,
                    subject: subject,
                    html: htmlToSend,
                    attachments: attachment ? attachment.attachments : [],
                };
                const sendMail = this.sendCronMail({ body, values });
                return sendMail;
            }
            catch (error) {
                return yield this.cronNotificationMail(values, error);
            }
        });
    }
    cronNotificationMail(values, error) {
        return __awaiter(this, void 0, void 0, function* () {
            if (values.cronConfiguration.alert_notification === "Y") {
                const email = values.cronConfiguration.notification_email_to;
                const rows = email.split(",");
                const array = rows.map((row) => row);
                let body = {
                    to: array,
                    from: process.env.EMAIL_NURA,
                    subject: "failed",
                    html: "Cron Failed due to" + " " + error,
                };
                const sendMail = this.sendCronMail({ body, values });
                return sendMail;
            }
        });
    }
    sendCronMail({ body, values }) {
        return __awaiter(this, void 0, void 0, function* () {
            sendGrid.setApiKey("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");
            return yield sendGrid.sendMultiple(body).then((result) => __awaiter(this, void 0, void 0, function* () {
                let status = null;
                let remark = null;
                if (result) {
                    status = "SUCS";
                    remark = "Mail Sent Successfully";
                    body = Object.assign(Object.assign({}, body), { mob_sendstatus: status, mob_sendremarks: remark, mob_templateptr: values.messageTemplate.mt_code });
                }
                else {
                    status = "FAIL";
                    remark = "Mail Sent Failed";
                    body = Object.assign(Object.assign({}, body), { mob_sendstatus: status, mob_sendremarks: remark, mob_templateptr: values.messageTemplate.mt_code });
                }
                return result;
            }));
        });
    }
    generatePDF({ subject, table_data, headings_uniq }) {
        return __awaiter(this, void 0, void 0, function* () {
            let doc = new PDFDocument({ margin: 30, layout: "landscape" });
            return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                let buffers = [];
                doc.image("./logo.png", 30, 15, { width: 60 });
                yield Promise.all(table_data.map((data) => __awaiter(this, void 0, void 0, function* () {
                    yield Promise.all(data.map((value, index) => {
                        if (value === null)
                            data[index] = "";
                    }));
                })));
                doc.moveDown();
                const table = {
                    title: subject,
                    headers: headings_uniq,
                    rows: table_data,
                };
                console.log("Creating Table");
                yield doc.table(table, {
                    prepareRow: (row, i) => doc.font("Helvetica").fontSize(6),
                });
                doc.image("./fuji-dkh.png", doc.page.width - 200, 15, { width: 100 });
                yield doc.end();
                yield doc.on("data", (arr) => {
                    buffers.push(arr);
                });
                yield doc.on("end", () => {
                    let pdfData = new Uint8Array(Buffer.concat(buffers));
                    resolve(pdfData);
                });
            }));
        });
    }
};
MsgTemplateService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, common_1.Inject)(constants_1.MSGTEMPLATE)),
    __param(1, (0, common_1.Inject)(constants_1.MSGTEMPLATE)),
    __metadata("design:paramtypes", [msgtemplate_entity_1.MsgTemplate, Object, common_2.UtilityService])
], MsgTemplateService);
exports.MsgTemplateService = MsgTemplateService;
