"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CoreCronController = void 0;
const common_1 = require("@nestjs/common");
const core_cron_service_1 = require("./core-cron.service");
const schedule_1 = require("@nestjs/schedule");
let CoreCronController = class CoreCronController {
    onModuleInit() {
        return this.coreCronService.initializeCron();
    }
    constructor(coreCronService, schedulerRegistry) {
        this.coreCronService = coreCronService;
        this.schedulerRegistry = schedulerRegistry;
    }
    triggerCron(id) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.coreCronService.executeCron(id);
        });
    }
    getCrons() {
        return __awaiter(this, void 0, void 0, function* () {
            const jobs = yield this.schedulerRegistry.getCronJobs();
            jobs.forEach((value, key, map) => {
                let next;
                try {
                    next = value.nextDates().toDate();
                }
                catch (e) {
                    next = 'error: next fire date is in the past!';
                }
                console.log(`job: ${key} -> next: ${next}`);
            });
            return jobs;
        });
    }
    refresh() {
        return __awaiter(this, void 0, void 0, function* () {
            const result = yield this.coreCronService.refreshCron();
            return result;
        });
    }
};
__decorate([
    (0, common_1.Get)('trigger-cron/:id'),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], CoreCronController.prototype, "triggerCron", null);
__decorate([
    (0, common_1.Get)('get-cron'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], CoreCronController.prototype, "getCrons", null);
__decorate([
    (0, common_1.Get)('refresh'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], CoreCronController.prototype, "refresh", null);
CoreCronController = __decorate([
    (0, common_1.Controller)('core-cron'),
    __metadata("design:paramtypes", [core_cron_service_1.CoreCronService,
        schedule_1.SchedulerRegistry])
], CoreCronController);
exports.CoreCronController = CoreCronController;
