import { CoreCron } from "./entities/core-cron.entity";
import { CronJob } from "cron";
import { CoreScriptsService } from "../core-scripts/core-scripts.service";
import { BaseService, UtilityService } from "../../common";
import { MsgTemplateService } from "../../business/communications/msgtemplate/msgtemplate.service";
import { SchedulerRegistry } from "@nestjs/schedule";
export declare class CoreCronService extends BaseService<CoreCron> {
    private readonly model;
    private readonly coreCron;
    private coreScriptService;
    private utilityService;
    private msgTemplateService;
    private schedulerRegistry;
    constructor(model: CoreCron, coreCron: typeof CoreCron, coreScriptService: CoreScriptsService, utilityService: UtilityService, msgTemplateService: MsgTemplateService, schedulerRegistry: SchedulerRegistry);
    refreshCron(): Promise<Map<string, CronJob<null, null>>>;
    initializeCron(): Promise<void>;
    groupingLogic(data: any, configuration: any): Promise<{
        [x: number]: string;
        results: any;
        headings: any[];
    }[]>;
    addNewJob({ values }: {
        values: any;
    }): Promise<void>;
    executeCron(id: any): Promise<void>;
}
