import { ModuleMetadata, Type } from "@nestjs/common/interfaces";
import { SequelizeOptions } from "sequelize-typescript";
export interface TenancyValidator {
    setTenantId(tenantId: string): TenancyValidator;
    validate(): Promise<void>;
}
export interface TenancyModuleOptions extends Record<string, any> {
    isTenantFromSubdomain?: boolean;
    tenantIdentifier?: string;
    credentials: (id: string) => Promise<SequelizeOptions> | SequelizeOptions;
    validator?: (tenantId: string) => TenancyValidator;
    options?: any;
    whitelist?: any;
    forceCreateCollections?: boolean;
}
export interface TenancyOptionsFactory {
    createTenancyOptions(): Promise<TenancyModuleOptions> | TenancyModuleOptions;
}
export interface TenancyModuleAsyncOptions extends Pick<ModuleMetadata, "imports"> {
    useExisting?: Type<TenancyOptionsFactory>;
    useClass?: Type<TenancyOptionsFactory>;
    useFactory?: (...args: any[]) => Promise<TenancyModuleOptions> | TenancyModuleOptions;
    inject?: any[];
}
